require "import"
import "com.androlua.*"
import "java.util.Locale"
import "android.net.Uri"

-- Function to split the text into smaller chunks
function splitText(text, maxLength)
    local chunks = {}
    for i = 1, #text, maxLength do
        local chunk = text:sub(i, i + maxLength - 1)
        table.insert(chunks, chunk)
    end
    return chunks
end

-- Maximum characters per chunk
local maxCharacters = 3000 -- Each chunk will have a maximum of 3000 characters
local textToTranslate = this.getText(node) -- Input text to translate
local urlBase = "https://translate.google.com/m?sl=auto&tl=ur&q="

-- Split the text into smaller chunks
local chunks = splitText(textToTranslate, maxCharacters)

-- Store translations in order
local translations = {}
local count = 0 -- Track completed translations

-- Function to handle translation for a single chunk
local function translateChunk(index, chunk)
    local url = urlBase .. Uri.encode(chunk)
    Http.get(url, function(status, result)
        if status == 200 then
            local translatedText = result:match('<div class="result%-container">([^<]+)</div>')
            if translatedText then
                translations[index] = translatedText -- Store in the correct order
                count = count + 1
                -- Check if all chunks are translated
                if count == #chunks then
                    local finalTranslation = table.concat(translations, "\n") -- Combine all translations
                    showPopup(finalTranslation) -- Show final translation
                end
            else
                print("Translation not found for chunk: " .. index)
            end
        else
            print("Error translating chunk: " .. index)
        end
    end)
end

-- Translate each chunk
for i, chunk in ipairs(chunks) do
    translateChunk(i, chunk)
end

-- Function to display the final translated text
function showPopup(translatedText)
    print("Translated Text:\n" .. translatedText) -- Replace with your desired display method
end